      SUBROUTINE CALCSTRESSTENSOR
      USE VARIABLES
      USE CONSTANTS
      DOUBLE PRECISION :: PT(3,3),TM(3,3)

      CALL INVERSE (HMAT,HINMAT)
      CALL CALCVOLUME
      PT = 0.0D0
      TM = MATMUL(HVMAT,HINMAT)

      DO I = 1, N
         XX = VX(I) - ( TM(1,1) * RX(I) + TM(1,2) * RY(I) + TM(1,3) * RZ(I) )
         YY = VY(I) - ( TM(2,1) * RX(I) + TM(2,2) * RY(I) + TM(2,3) * RZ(I) )
         ZZ = VZ(I) - ( TM(3,1) * RX(I) + TM(3,2) * RY(I) + TM(3,3) * RZ(I) )
         PT(1,1) = PT(1,1) + XX * XX * WM(I)
         PT(2,1) = PT(2,1) + YY * XX * WM(I)
         PT(3,1) = PT(3,1) + ZZ * XX * WM(I)
         PT(1,2) = PT(1,2) + XX * YY * WM(I)
         PT(2,2) = PT(2,2) + YY * YY * WM(I)
         PT(3,2) = PT(3,2) + ZZ * YY * WM(I)
         PT(1,3) = PT(1,3) + XX * ZZ * WM(I)
         PT(2,3) = PT(2,3) + YY * ZZ * WM(I)
         PT(3,3) = PT(3,3) + ZZ * ZZ * WM(I)
      ENDDO
      PT = PT + DMAT
      PT = PT / V

      SGMMAT = - PT
      
      END
